<template>
	<f7-page name="residentreportform" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Aduan</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Aduan</f7-nav-title-large>
		</f7-navbar>
		<f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
			<h3 class="no-margin">Penting!</h3>
			<p>Silahkan laporkan keluhan atau aspirasi anda sebagai warga perumahan. Laporan anda akan ditindaklanjuti sampai dengan terselesaikan.</p>
		</f7-block>
		<f7-block class="no-margin">
			<div class="uploader margin-medium-bottom">
                <div v-if="residentreport && residentreport.medias && residentreport.medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in residentreport.medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.medium})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Foto</span>
                        </a>
                    </div>
                </div>
                <div v-else-if="medias.length > 0">
                    <div :id="`image-${media.id}`" class="uploader-item image-item" v-for="media in medias" v-bind:key="media.id">
                        <a href="#" @click="handleMediaDelete($event, media.id)"  :style="`background-image: url(${media.url.original})`"></a>
                    </div>
                    <div class="uploader-item">
                        <a class="text-align-center add-image" href="#" @click="handleUpload">
                            <f7-icon f7="add" size="50"></f7-icon>
                            <span class="display-block">Foto</span>
                        </a>
                    </div>
                </div>
                <div v-else class="uploader-item">
                    <a class="text-align-center add-image" href="#" @click="handleUpload">
                        <f7-icon f7="add" size="50"></f7-icon>
                        <span class="display-block">Foto</span>
                    </a>
                </div>
            </div>
		</f7-block>
		<f7-list no-hairlines class="no-margin">							
			<f7-list-input
				ref="title"
				label="Judul aduan"
				placeholder="Ketik judul aduan"
				maxlength="255"
				clear-button
				:value="residentReportForm.title"
				@input="residentReportForm.title = $event.target.value">
			</f7-list-input>
			<f7-list-input
				ref="body"
				type="textarea"
				label="Aduan"
				placeholder="Ketik aduan anda"
				resizable					
				:value="residentReportForm.body"
				@input="residentReportForm.body = $event.target.value">
			</f7-list-input>			
			<f7-list-item title="Kategori" smart-select :smart-select-params="{closeOnSelect: true}">
				<select 
					ref="category" 
					name="category" 
					:value="residentReportForm.category"
					@change="residentReportForm.category = $event.target.value">
					<option
						v-for="item in residentReportCategories" 
						:value="item.id"
						v-bind:key="item.id">{{ convertAmpersand(item.name) }}</option>
				</select>
			</f7-list-item>
			<f7-list-item>
				<div class="item-title">Kirim detil lokasi?</div>
				<f7-toggle 
					color="blue"
					value="1"
					:checked="showMap"
					@toggleChange="handleShowMap($event)"></f7-toggle>
			</f7-list-item>
			<f7-list>
				<GmapMap 
					id="map"
					v-if="showMap == true" 
					ref="mapRef"
					:options="{
						zoomControl: true,
						mapTypeControl: false,
						scaleControl: false,
						streetViewControl: false,
						rotateControl: false,
						fullscreenControl: true,
						disableDefaultUi: false,
						scrollwheel: false
					}"
					:zoom="map.zoom"
					:center="map.center"
					:draggable="true"
					@center_changed="handleCenterChanged($event)">
				</GmapMap>
			</f7-list>			
		</f7-list>
		<br>
		<f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Publikasikan</f7-button>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { gmapApi } from 'vue2-google-maps';
import { parseError, dateFormat, convertAmpersand } from '../js/utils';
import { setTimeout } from 'timers';
export default {
	name: 'ResidentReportForm',
	data(){
		return{
			formType: 'Buat',
			status: [{
				value: 'draft',
				label: 'Simpan'
			}, {
				value: 'publish',
				label: 'Publikasikan'
			}],
			showMap: false,
			map: {
				zoom: 14,
				center: {
					lat: -2.9760735,
					lng: 104.77543070000002
				}
			},
			residentReportForm: {
				id: null,
				title: '',
				body: '',
				category: null,
				latitude: null,
				longitude: null,
				status: 'draft',
				medias: []
			},
			medias: []
		}
	},
	computed: {
		...mapGetters('auth', ['user']),
		...mapGetters('category', ['residentReportCategories']),
		...mapGetters('residentreport', [
			'residentreports',
			'residentreport',
			'pagination'
		]),
		currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
	},
	methods: {
		dateFormat,
		convertAmpersand,
		google: gmapApi,
		getCategories(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('category/getCategories', {
				module: 'residentreport',
				page: 1,
				perpage: 25,
				only: 'id,name,slug'
			});
		},
		onPageBeforeIn(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const $el = $$(self.$el);

			// if(self.$f7route.params && self.$f7route.params.id){
			// 	self.formType = 'Ubah';
			// 	self.residentReportForm.id = self.$f7route.params.id;
			
			// 	app.preloader.show('green');

			// 	self.$store.dispatch('residentreport/viewResidentReport', {
			// 		id: self.residentReportForm.id,
			// 		only: 'id,number,title,body,created,updated,category.id,category.name,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
			// 	}).then((response) => {
					
			// 		self.residentReportForm.title = self.residentreport.title;
			// 		self.residentReportForm.body = self.residentreport.body;
			// 		self.residentReportForm.category = self.residentreport.category.id.toString();

			// 		if(self.residentreport.latitude && self.residentreport.longitude){
			// 			self.showMap = true;
			// 			self.residentReportForm.latitude = self.residentreport.latitude;
			// 			self.residentReportForm.longitude = self.residentreport.longitude;

			// 			self.map.zoom = 18;
			// 			self.map.center.lat = self.residentreport.latitude;
			// 			self.map.center.lng = self.residentreport.longitude;
			// 		}

			// 		$el.find('select').find('option[value="'+self.residentreport.category.id+'"]').prop('selected', true).trigger('change'); 

			// 		app.preloader.hide();
			// 	});
			// }

			// if(self.currentLocation != null){
			// 	self.map.zoom = 18;
			// 	self.map.center.lat = self.currentLocation.latitude;
			// 	self.map.center.lng = self.currentLocation.longitude;
			// 	self.residentReportForm.latitude = self.currentLocation.latitude;
            //     self.residentReportForm.longitude = self.currentLocation.longitude;
			// }
			self.getCategories();
		},
		onPageBeforeOut(page){
			const self = this;

			if(page.detail.name == 'residentreportform'){
				self.residentReportForm = {
					id: null,
					title: '',
					body: '',
					category: null,
					latitude: null,
					longitude: null,
					status: 'draft',
					medias: []
				},
				self.medias = [];
				self.formType = 'Buat';
			}
		},
		handleShowMap(value){
			const self = this;
			self.showMap = value;

			if(value == true){
				self.setCenterMarker();
			}
		},
		setCenterMarker(){
			const self = this;
			const $$ = self.$$;

			setTimeout(() => {
				self.$refs.mapRef.$mapPromise.then((map) => {
					$$('<div/>').addClass('centerMarker').appendTo(map.getDiv());
				});
			}, 100);
		},
		handleCenterChanged(e){
			const self = this;
			setTimeout(() => {
				self.residentReportForm.latitude = e.lat();
				self.residentReportForm.longitude = e.lng();
			}, 3000);
		},
		doSubmit(e, status){
			const self = this;
			const app = self.$f7;

			if(self.residentReportForm.title.trim().length == 0){
				app.dialog.alert('Judul aduan wajib diisi', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/.test(self.residentReportForm.title) == false){
				app.dialog.alert('Judul aduan hanya boleh diisi dengan dengan huruf, angka, tanda minus, tanda kurung tanda plus, garis miring, titik, koma dan spasi.', 'RingSatu');
				return false;
			}else if(self.residentReportForm.body.trim().length == 0){
				app.dialog.alert('Aduan wajib diisi', 'RingSatu');
				return false;
			}else if(self.residentReportForm.category == null){
				app.dialog.alert('Kategori aduan wajib diisi', 'RingSatu');
				return false;
			}else if(self.showMap && self.residentReportForm.latitude == null && self.residentReportForm.longitude == null){
				app.dialog.alert('Silahkan tentukan lokasi aduan', 'RingSatu');
				return false;
			}

			app.preloader.show('green');

			let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = self.$f7route.params.id;
				action = 'residentreport/editResidentReport';
			}else{
				action = 'residentreport/createResidentReport';
			}

			params.title = self.residentReportForm.title;
			params.body = self.residentReportForm.body;
			params.category = parseInt(self.residentReportForm.category);
			params.latitude = self.residentReportForm.latitude;
			params.longitude = self.residentReportForm.longitude;
			params.author = self.user.id;
			params.status = status;
			params.medias = self.residentReportForm.medias;
			params.only = 'id,number,title,body,created,updated,category.id,category.name,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'

			self.$store.dispatch(action, params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
		},
		handleMediaDelete(e, imageId){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;

			app.dialog.confirm('Anda akan menghapus media ini. File tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Hapus File', function(){
				app.preloader.show('green');

				if(self.formType == 'Ubah'){
					self.$store.dispatch('media/deleteMedia', {
						id: parseInt(imageId),
						endpoint: 'residentreport'
					}).then((response) => {
						$$('#image-'+imageId).remove();
						app.preloader.hide();
					});
				}else{
					self.$store.dispatch('media/deleteTmpMedia', {
						id: parseInt(imageId)
					}).then((response) => {
						$$('#image-'+imageId).remove();
						app.preloader.hide();
					});
				}
			})
		},
		handleUpload(){

			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const $el = self.$el;

			var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {

									bannerImagePath = bannerImagePath.replace(/\s/g,'%20');

                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/residentreport/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);

                                            if(self.formType == 'Ubah'){
                                                self.residentreport.medias.push(response.data.media);
                                            }else{
                                                self.residentReportForm.medias.push(response.data.media.id);
                                                self.medias.push(response.data.media);
                                            }
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {

									bannerImagePath = bannerImagePath.replace(/\s/g,'%20');

                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/residentreport/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
									}
									
                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

										if(self.formType == 'Ubah'){
                                            self.residentreport.medias.push(response.data.media);
                                        }else{
                                            self.residentReportForm.medias.push(response.data.media.id);
                                            self.medias.push(response.data.media);
                                        }

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
		}
	},
}
</script>
